/* Generated by powerful Codeforces Tool
 * Author: $%U%$
 * Time: $%Y%$-$%M%$-$%D%$ $%h%$:$%m%$
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef unsigned long long ull;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const int INF = 1 << 30;

ll N, K;

vector<int> parent, height, seen;
vector<vector<int>> children;

int dfs(int u){
    int m = 0;
    for(auto x: children[u]){
        m = max(m, dfs(x) + 1);
    }
    R::sort(children[u], [&](int a, int b){ return height[a] < height[b]; });

    height[u] = m;
    return m;
}

void show_tree(){
    R(i, N + 1){
        cerr << "Node " << i << " : ";
        for(auto x: children[i]) cerr << x << " ";
        cerr << endl;
    }
}

stack<int> st;
one_go
void dfs_walk(int u){

}

void solve(){
    // Code goes here ...

    cin >> N >> K;

    parent.assign(N + 1, 0);
    F(i, 2, N + 1) cin >> parent[i];
    cerr << "Ran" << endl;

    children.assign(N + 1, vector<int>());
    F(i, 1, N + 1){
        children[parent[i]].push_back(i);
    }

    // show_tree();

    height.assign(N + 1, INF);
    dfs(1);
    for(auto x : height) cerr << x << " ";
    cerr << endl;



}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    // cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
